const request = require('request');


module.exports = function(config){

    const host =  config.INFOCHAT_DATA_SERVER;
    const BotmetricsMiddleware = {};

    BotmetricsMiddleware.receive = function (conversationId, message) {
        return sendRequest('/conversationhistories/' + conversationId, message).catch(e => e);
    };

    BotmetricsMiddleware.send = function (conversationId, message, isTest = false) {
        //   if (message) {
        return isTest ? returnTestRequest() : sendRequest('/conversationhistories/' + conversationId, message).catch(e => e);
        // }
    };

    BotmetricsMiddleware.updateData = function (conversationId, message) {
        return  sendRequest('/conversations/' + conversationId + '/userdata', message).catch(e => e);
    };

    BotmetricsMiddleware.trackIntent = function (message, isTest = false) {
        return isTest ? returnTestRequest() : sendRequest('/intentstracks', message).catch(e => e);
    };

    BotmetricsMiddleware.sendEmailRequest = function (message) {
        return sendRequest('/requests', message).catch(e => e);
    };

    BotmetricsMiddleware.registerNewConversation = function (data, isTest = false) {
        return isTest ? returnTestRequest() : sendRequest('/conversations', data).catch(e => e);
    };

    function returnTestRequest() {
        return Promise.resolve();
    }

    function sendRequest(uri, data) {
        // if (process.env.NODE_ENV != 'dev') {
        return new Promise((resolve, reject) => {
            console.log(host + uri);
            request.post({url: host + uri, json: data, timeout: 10000}, function (err, _resp, _body) {
                if (err) reject(err);
                resolve(_body);
            });
        });
        // }
    }
    return BotmetricsMiddleware;
};



